'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _StackRouter = require('../StackRouter');

var _StackRouter2 = _interopRequireDefault(_StackRouter);

var _TabRouter = require('../TabRouter');

var _TabRouter2 = _interopRequireDefault(_TabRouter);

var _NavigationActions = require('../../NavigationActions');

var _NavigationActions2 = _interopRequireDefault(_NavigationActions);

var _addNavigationHelpers = require('../../addNavigationHelpers');

var _addNavigationHelpers2 = _interopRequireDefault(_addNavigationHelpers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ROUTERS = {
  TabRouter: _TabRouter2.default,
  StackRouter: _StackRouter2.default
};

Object.keys(ROUTERS).forEach(function (routerName) {
  var Router = ROUTERS[routerName];

  describe('General router features - ' + routerName, function () {
    test('title is configurable using navigationOptions and getScreenOptions', function () {
      var FooView = function (_React$Component) {
        _inherits(FooView, _React$Component);

        function FooView() {
          _classCallCheck(this, FooView);

          return _possibleConstructorReturn(this, (FooView.__proto__ || Object.getPrototypeOf(FooView)).apply(this, arguments));
        }

        _createClass(FooView, [{
          key: 'render',
          value: function render() {
            return _react2.default.createElement('div', null);
          }
        }]);

        return FooView;
      }(_react2.default.Component);

      var BarView = function (_React$Component2) {
        _inherits(BarView, _React$Component2);

        function BarView() {
          _classCallCheck(this, BarView);

          return _possibleConstructorReturn(this, (BarView.__proto__ || Object.getPrototypeOf(BarView)).apply(this, arguments));
        }

        _createClass(BarView, [{
          key: 'render',
          value: function render() {
            return _react2.default.createElement('div', null);
          }
        }]);

        return BarView;
      }(_react2.default.Component);

      BarView.navigationOptions = { title: 'BarTitle' };

      var BazView = function (_React$Component3) {
        _inherits(BazView, _React$Component3);

        function BazView() {
          _classCallCheck(this, BazView);

          return _possibleConstructorReturn(this, (BazView.__proto__ || Object.getPrototypeOf(BazView)).apply(this, arguments));
        }

        _createClass(BazView, [{
          key: 'render',
          value: function render() {
            return _react2.default.createElement('div', null);
          }
        }]);

        return BazView;
      }(_react2.default.Component);

      BazView.navigationOptions = function (_ref) {
        var navigation = _ref.navigation;
        return { title: 'Baz-' + navigation.state.params.id };
      };

      var router = Router({
        Foo: { screen: FooView },
        Bar: { screen: BarView },
        Baz: { screen: BazView }
      });
      var routes = [{ key: 'A', routeName: 'Foo' }, { key: 'B', routeName: 'Bar' }, { key: 'A', routeName: 'Baz', params: { id: '123' } }];
      expect(router.getScreenOptions((0, _addNavigationHelpers2.default)({ state: routes[0], dispatch: function dispatch() {
          return false;
        } }), {}).title).toEqual(undefined);
      expect(router.getScreenOptions((0, _addNavigationHelpers2.default)({ state: routes[1], dispatch: function dispatch() {
          return false;
        } }), {}).title).toEqual('BarTitle');
      expect(router.getScreenOptions((0, _addNavigationHelpers2.default)({ state: routes[2], dispatch: function dispatch() {
          return false;
        } }), {}).title).toEqual('Baz-123');
    });
  });
});

test('Handles no-op actions with tabs within stack router', function () {
  var BarView = function BarView() {
    return _react2.default.createElement('div', null);
  };
  var FooTabNavigator = function FooTabNavigator() {
    return _react2.default.createElement('div', null);
  };
  FooTabNavigator.router = (0, _TabRouter2.default)({
    Zap: { screen: BarView },
    Zoo: { screen: BarView }
  });
  var TestRouter = (0, _StackRouter2.default)({
    Foo: {
      screen: FooTabNavigator
    },
    Bar: {
      screen: BarView
    }
  });
  var state1 = TestRouter.getStateForAction({ type: _NavigationActions2.default.INIT });
  var state2 = TestRouter.getStateForAction({ type: _NavigationActions2.default.NAVIGATE, routeName: 'Qux' });
  expect(state1).toEqual(state2);
  var state3 = TestRouter.getStateForAction({ type: _NavigationActions2.default.NAVIGATE, routeName: 'Zap' }, state2);
  expect(state2).toEqual(state3);
});

test('Handles deep action', function () {
  var BarView = function BarView() {
    return _react2.default.createElement('div', null);
  };
  var FooTabNavigator = function FooTabNavigator() {
    return _react2.default.createElement('div', null);
  };
  FooTabNavigator.router = (0, _TabRouter2.default)({
    Zap: { screen: BarView },
    Zoo: { screen: BarView }
  });
  var TestRouter = (0, _StackRouter2.default)({
    Bar: { screen: BarView },
    Foo: { screen: FooTabNavigator }
  });
  var state1 = TestRouter.getStateForAction({ type: _NavigationActions2.default.INIT });
  var expectedState = {
    index: 0,
    routes: [{
      key: 'Init',
      routeName: 'Bar'
    }]
  };
  expect(state1).toEqual(expectedState);
  var state2 = TestRouter.getStateForAction({ type: _NavigationActions2.default.NAVIGATE, routeName: 'Foo', action: { type: _NavigationActions2.default.NAVIGATE, routeName: 'Zoo' } }, state1);
  expect(state2 && state2.index).toEqual(1);
  /* $FlowFixMe */
  expect(state2 && state2.routes[1].index).toEqual(1);
});

test('Supports lazily-evaluated getScreen', function () {
  var BarView = function BarView() {
    return _react2.default.createElement('div', null);
  };
  var FooTabNavigator = function FooTabNavigator() {
    return _react2.default.createElement('div', null);
  };
  FooTabNavigator.router = (0, _TabRouter2.default)({
    Zap: { screen: BarView },
    Zoo: { screen: BarView }
  });
  var TestRouter = (0, _StackRouter2.default)({
    Foo: {
      screen: FooTabNavigator
    },
    Bar: {
      getScreen: function getScreen() {
        return BarView;
      }
    }
  });
  var state1 = TestRouter.getStateForAction({ type: _NavigationActions2.default.INIT });
  var state2 = TestRouter.getStateForAction({ type: _NavigationActions2.default.NAVIGATE, routeName: 'Qux' });
  expect(state1).toEqual(state2);
  var state3 = TestRouter.getStateForAction({ type: _NavigationActions2.default.NAVIGATE, routeName: 'Zap' }, state2);
  expect(state2).toEqual(state3);
});